"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Errors = void 0;
const petitio_1 = __importDefault(require("petitio"));
class Request {
    constructor(client, method, path, body) {
        this.client = null;
        this.method = null;
        this.url = null;
        this.body = null;
        this.reason = null;
        this.response = null;
        this.client = client;
        this.method = method;
        this.url = `https://discord.com/api/v9${path}`;
        this.body = body !== null && body !== void 0 ? body : null;
    }
    make() {
        return __awaiter(this, void 0, void 0, function* () {
            let req = (0, petitio_1.default)(this.url, this.method)
                .timeout(5000)
                .header({
                'Authorization': `Bot ${this.client.token}`,
                'User-Agent': `Birb (+https://birb.js.org)`,
            });
            if (this.body) {
                req.header('Content-Type', 'application/json; charset=utf-8');
                req.body(this.body);
            }
            if (this.reason) {
                req.header('X-Audit-Log-Reason', this.reason);
            }
            let res = yield req.send();
            let body = res.json();
            return body;
        });
    }
}
exports.default = Request;
class Errors {
}
exports.Errors = Errors;
