"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("../../..");
const Guild_1 = __importDefault(require("../../Guild"));
function GUILD_CREATE(ws, data) {
    return __awaiter(this, void 0, void 0, function* () {
        ws.client.debug(`received guild: ${data.id}`);
        let guild = new Guild_1.default(ws.client, data);
        ws.client.guilds.cache.set(guild.id, guild);
        if (ws.status === __1.Status.WAITING_FOR_GUILDS) {
            ws.expectedGuilds.delete(data.id);
            ws.client.emit('guildAvailable', guild);
            if (ws.expectedGuilds.size === 0) {
                ws.client.debug(`we've received all guilds; setting to ready`);
                ws.setStatus(__1.Status.READY);
                ws.client.emit('ready');
            }
        }
        else {
            ws.client.emit('guildCreate', guild);
        }
    });
}
exports.default = GUILD_CREATE;
