"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Constants_1 = require("../../../util/Constants");
function READY(ws, data) {
    return __awaiter(this, void 0, void 0, function* () {
        ws.expectedGuilds = new Set(data.guilds.map((d) => d.id));
        ws.setSessionIdentifier(data.session_id);
        ws.setStatus(Constants_1.Status.WAITING_FOR_GUILDS);
        if (!ws.expectedGuilds) {
            ws.client.debug('we didn\'t need to receive any guilds; marking as ready');
            ws.setStatus(Constants_1.Status.READY);
            ws.client.emit('ready');
        }
    });
}
exports.default = READY;
